com.orsoncharts.style

## Class StandardChartStyle

- java.lang.Object
- - com.orsoncharts.style.StandardChartStyle

- All Implemented Interfaces:
    ChartStyle, java.io.Serializable, java.lang.Cloneable

      public class StandardChartStyle
      extends java.lang.Object
      implements ChartStyle, java.lang.Cloneable, java.io.Serializable

  A standard implementation of the `ChartStyle` interface.
  NOTE: This class is serializable, but the serialization format is subject to change in future releases and should not be relied upon for persisting instances of this class.
  Since:
    1.2
  See Also:
    Serialized Form

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static java.awt.Color` | `DEFAULT_AXIS_LABEL_COLOR` The default foreground color for axis labels.
    `static java.awt.Font` | `DEFAULT_AXIS_LABEL_FONT` The default font for axis labels.
    `static java.awt.Color` | `DEFAULT_AXIS_TICK_LABEL_COLOR` The default foreground color for axis tick labels.
    `static java.awt.Font` | `DEFAULT_AXIS_TICK_LABEL_FONT` The default font for axis tick labels.
    `static java.awt.Color` | `DEFAULT_CHARTBOX_COLOR` The default chartbox color.
    `static boolean` | `DEFAULT_COLUMN_GRIDLINES_VISIBLE` The default visibility for gridlines perpendicular to the column-axis.
    `static java.awt.Color` | `DEFAULT_GRIDLINE_COLOR` The default gridline color.
    `static java.awt.Stroke` | `DEFAULT_GRIDLINE_STROKE` The default gridline stroke.
    `static java.awt.Color` | `DEFAULT_LEGEND_FOOTER_COLOR` The default foreground color for the legend footer if there is one.
    `static java.awt.Font` | `DEFAULT_LEGEND_FOOTER_FONT` The default font for legend footers.
    `static java.awt.Color` | `DEFAULT_LEGEND_HEADER_COLOR` The default foreground color for the legend header if there is one.
    `static java.awt.Font` | `DEFAULT_LEGEND_HEADER_FONT` The default font for legend headers.
    `static java.awt.Color` | `DEFAULT_LEGEND_ITEM_BACKGROUND_COLOR` The default legend item background color.
    `static java.awt.Color` | `DEFAULT_LEGEND_ITEM_COLOR` The default legend item color.
    `static java.awt.Font` | `DEFAULT_LEGEND_ITEM_FONT` The default font for legend item text.
    `static java.awt.Shape` | `DEFAULT_LEGEND_ITEM_SHAPE` The default legend item shape.
    `static java.awt.Color` | `DEFAULT_MARKER_FILL_COLOR`
    `static java.awt.Color` | `DEFAULT_MARKER_LABEL_COLOR`
    `static java.awt.Font` | `DEFAULT_MARKER_LABEL_FONT`
    `static java.awt.Color` | `DEFAULT_MARKER_LINE_COLOR`
    `static java.awt.Stroke` | `DEFAULT_MARKER_LINE_STROKE`
    `static boolean` | `DEFAULT_ROW_GRIDLINES_VISIBLE` The default visibility for gridlines perpendicular to the row-axis.
    `static java.awt.Color` | `DEFAULT_SECTION_LABEL_COLOR` The default color for pie section labels.
    `static java.awt.Font` | `DEFAULT_SECTION_LABEL_FONT` The default font for pie section labels.
    `static java.awt.Font` | `DEFAULT_SUBTITLE_FONT` The default subtitle font.
    `static java.awt.Color` | `DEFAULT_TEXT_BACKGROUND_COLOR` The default background color for the title and subtitle, and legend header and footer.
    `static java.awt.Font` | `DEFAULT_TITLE_FONT` The default title font.
    `static boolean` | `DEFAULT_X_GRIDLINES_VISIBLE` The default visibility for gridlines perpendicular to the x-axis.
    `static boolean` | `DEFAULT_Y_GRIDLINES_VISIBLE` The default visibility for gridlines perpendicular to the y-axis.
    `static boolean` | `DEFAULT_Z_GRIDLINES_VISIBLE` The default visibility for gridlines perpendicular to the z-axis.

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `StandardChartStyle()` Creates a new instance with default attributes.
    `StandardChartStyle(StandardChartStyle source)` A copy constructor that creates a new style that is a copy of an existing style (note that the existing style listeners are not copied).

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `addChangeListener(ChartStyleChangeListener listener)` Registers a listener to receive notification of changes to the chart.
    `ChartStyle` | `clone()` Returns a clone of the chart style (note that the change listeners are not cloned).
    `static java.awt.Font` | `createDefaultFont(int style, int size)` Creates a default font with the specified `style` and `size`.
    `boolean` | `equals(java.lang.Object obj)` Tests this instance for equality with an arbitrary object.
    `protected void` | `fireChangeEvent()` Sends a `ChartStyleChangeEvent` to all registered listeners.
    `java.awt.Color` | `getAxisLabelColor()` Returns the foreground color for the axis label (the main label, not the tick labels).
    `java.awt.Font` | `getAxisLabelFont()` Returns the font used for the axis label.
    `java.awt.Color` | `getAxisTickLabelColor()` Returns the color used to draw the tick labels on the axis.
    `java.awt.Font` | `getAxisTickLabelFont()` Returns the font used for the axis tick labels.
    `RectanglePainter` | `getBackgroundPainter()` Returns the background painter.
    `java.awt.Color` | `getChartBoxColor()` Returns the color used for the `ChartBox3D` (for those charts that have one).
    `boolean` | `getColumnAxisGridlinesVisible()` Returns the flag that controls whether or not gridlines are drawn perpendicular to the column axis in category plots.
    `java.awt.Color` | `getGridlineColor()` Returns the color used for the gridlines.
    `java.awt.Stroke` | `getGridlineStroke()` Returns the stroke used to draw the gridlines.
    `java.awt.Color` | `getLegendFooterBackgroundColor()` Returns the background color for the legend footer.
    `java.awt.Color` | `getLegendFooterColor()` Returns the foreground color for the legend footer.
    `java.awt.Font` | `getLegendFooterFont()` Returns the font for the legend footer.
    `java.awt.Color` | `getLegendHeaderBackgroundColor()` Returns the background color for the legend header.
    `java.awt.Color` | `getLegendHeaderColor()` Returns the foreground color for the legend header.
    `java.awt.Font` | `getLegendHeaderFont()` Returns the font used to display the legend header.
    `java.awt.Color` | `getLegendItemBackgroundColor()` Returns the background color for legend items.
    `java.awt.Color` | `getLegendItemColor()` Returns the foreground color used for the legend items.
    `java.awt.Font` | `getLegendItemFont()` Returns the font used for legend item text.
    `java.awt.Shape` | `getLegendItemShape()` Returns the standard shape for legend items.
    `java.awt.Color` | `getMarkerFillColor()` Returns the color used to fill the band representing the marker range.
    `java.awt.Color` | `getMarkerLabelColor()` Returns the color for the marker labels.
    `java.awt.Font` | `getMarkerLabelFont()` Returns the font used to draw marker labels.
    `java.awt.Color` | `getMarkerLineColor()` Returns the color used to draw marker lines.
    `java.awt.Stroke` | `getMarkerLineStroke()` Returns the stroke used to draw marker lines.
    `boolean` | `getRowAxisGridlinesVisible()` Returns the flag that controls whether or not gridlines are drawn perpendicular to the row axis in category plots.
    `java.awt.Color` | `getSectionLabelColor()` Returns the color used to display pie section labels.
    `java.awt.Font` | `getSectionLabelFont()` Returns the font used for pie section labels.
    `java.awt.Color[]` | `getStandardColors()` Returns the standard colors for the style.
    `java.awt.Color` | `getSubtitleBackgroundColor()` Returns the background color for the chart subtitle.
    `java.awt.Color` | `getSubtitleColor()` Returns the color for the chart subtitle.
    `java.awt.Font` | `getSubtitleFont()` Returns the font used for the chart subtitle.
    `java.awt.Color` | `getTitleBackgroundColor()` Returns the background color for the title.
    `java.awt.Color` | `getTitleColor()` Returns the title color.
    `java.awt.Font` | `getTitleFont()` Returns the chart title font.
    `boolean` | `getXAxisGridlinesVisible()` Returns the flag that specifies whether or not gridlines are drawn for the x-axis.
    `boolean` | `getYAxisGridlinesVisible()` Returns the flag that specifies whether or not gridlines are drawn for the y-axis.
    `boolean` | `getZAxisGridlinesVisible()` Returns the flag that specifies whether or not gridlines are drawn for the z-axis.
    `boolean` | `isNotify()` Returns a flag that controls whether or not change events are sent to registered listeners.
    `void` | `notifyListeners(ChartStyleChangeEvent event)` Notifies all registered listeners that the chart style has been modified.
    `void` | `removeChangeListener(ChartStyleChangeListener listener)` Deregisters a listener so that it no longer receives notification of changes to the chart.
    `void` | `setAxisLabelColor(java.awt.Color color)` Sets the foreground color for the axis label and sends a `ChartStyleChangeEvent` to all registered listeners.
    `void` | `setAxisLabelFont(java.awt.Font font)` Sets the font used for the axis label and sends a `ChartStyleChangeEvent` to all registered listeners.
    `void` | `setAxisTickLabelColor(java.awt.Color color)` Sets the foreground color for the axis tick labels and sends a `ChartStyleChangeEvent` to all registered listeners.
    `void` | `setAxisTickLabelFont(java.awt.Font font)` Sets the font used for the axis tick labels and sends a `ChartStyleChangeEvent` to all registered listeners.
    `void` | `setBackgroundPainter(RectanglePainter painter)` Sets the background painter.
    `void` | `setChartBoxColor(java.awt.Color color)` Sets the color used for the chart box and sends a `ChartStyleChangeEvent` to all registered listeners.
    `void` | `setGridlineColor(java.awt.Color color)` Sets the color for the gridlines and sends a `ChartStyleChangeEvent` to all registered listeners.
    `void` | `setGridlineStroke(java.awt.Stroke stroke)` Sets the stroke used for gridlines and sends a `ChartStyleChangeEvent` to all registered listeners.
    `void` | `setLegendFooterBackgroundColor(java.awt.Color color)` Sets the background color for the legend footer and sends a `ChartStyleChangeEvent` to all registered listeners.
    `void` | `setLegendFooterColor(java.awt.Color color)` Sets the foreground color for the legend footer and sends a `ChartStyleChangeEvent` to all registered listeners.
    `void` | `setLegendFooterFont(java.awt.Font font)` Sets the legend footer font and sends a `ChartStyleChangeEvent` to all registered listeners.
    `void` | `setLegendHeaderBackgroundColor(java.awt.Color color)` Sets the background color for the legend header and sends a `ChartStyleChangeEvent` to all registered listeners.
    `void` | `setLegendHeaderColor(java.awt.Color color)` Sets the foreground color for the legend header and sends a `ChartStyleChangeEvent` to all registered listeners.
    `void` | `setLegendHeaderFont(java.awt.Font font)` Sets the legend header font and sends a `ChartStyleChangeEvent` to all registered listeners.
    `void` | `setLegendItemBackgroundColor(java.awt.Color color)` Sets the background color for legend items and sends a `ChartStyleChangeEvent` to all registered listeners.
    `void` | `setLegendItemColor(java.awt.Color color)` Sets the foreground color used for legend item text and sends a `ChartStyleChangeEvent` to all registered listeners.
    `void` | `setLegendItemFont(java.awt.Font font)` Sets the legend item font and sends a `ChartStyleChangeEvent` to all registered listeners.
    `void` | `setLegendItemShape(java.awt.Shape shape)` Sets the default shape for legend items and sends a `ChartStyleChangeEvent` to all registered listeners.
    `void` | `setMarkerFillColor(java.awt.Color color)` Sets the marker fill color and sends a change event to all registered listeners.
    `void` | `setMarkerLabelColor(java.awt.Color color)` Sets the color for the marker labels and sends a change event to all registered listeners.
    `void` | `setMarkerLabelFont(java.awt.Font font)` Sets the marker label font and sends a change event to all registered listeners.
    `void` | `setMarkerLineColor(java.awt.Color color)` Sets the marker line color and sends a change event to all registered listeners.
    `void` | `setMarkerLineStroke(java.awt.Stroke stroke)` Sets the stroke for the marker lines and sends a change event to all registered listeners.
    `void` | `setNotify(boolean notify)` Sets a flag that controls whether or not listeners receive `ChartStyleChangeEvent` notifications.
    `void` | `setSectionLabelColor(java.awt.Color color)` Sets the color used for the pie section labels and sends a `ChartStyleChangeEvent` to all registered listeners.
    `void` | `setSectionLabelFont(java.awt.Font font)` Sets the font used for the pie section labels and sends a `ChartStyleChangeEvent` to all registered listeners.
    `void` | `setStandardColors(java.awt.Color... colors)` Sets the standard colors for the chart and sends a `ChartStyleChangeEvent` to all registered listeners.
    `void` | `setSubtitleBackgroundColor(java.awt.Color color)` Sets the background color for the chart subtitle and sends a change event to all registered listeners.
    `void` | `setSubtitleColor(java.awt.Color color)` Sets the color for the chart subtitle and sends a change event to all registered listeners.
    `void` | `setSubtitleFont(java.awt.Font font)` Sets the font used for the chart subtitle and sends a `ChartStyleChangeEvent` to all registered listeners.
    `void` | `setTitleBackgroundColor(java.awt.Color color)` Sets the background color for the title and sends a change event to all registered listeners.
    `void` | `setTitleColor(java.awt.Color color)` Sets the foreground color for the chart title and sends a change event to all registered listeners.
    `void` | `setTitleFont(java.awt.Font font)` Sets the font used for the chart title and sends a `ChartStyleChangeEvent` to all registered listeners.
    `void` | `setXAxisGridlinesVisible(boolean visible)` Sets the flag that controls whether or not gridlines are drawn for the x-axis and sends a `ChartStyleChangeEvent` to all registered listeners.
    `void` | `setYAxisGridlinesVisible(boolean visible)` Sets the flag that controls whether or not gridlines are drawn for the y-axis and sends a `ChartStyleChangeEvent` to all registered listeners.
    `void` | `setZAxisGridlinesVisible(boolean visible)` Sets the flag that controls whether or not gridlines are drawn for the z-axis and sends a `ChartStyleChangeEvent` to all registered listeners.

    - ### Methods inherited from class java.lang.Object

      `finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### DEFAULT_TEXT_BACKGROUND_COLOR

          public static final java.awt.Color DEFAULT_TEXT_BACKGROUND_COLOR

      The default background color for the title and subtitle, and legend header and footer.

    - #### DEFAULT_TITLE_FONT

          public static final java.awt.Font DEFAULT_TITLE_FONT

      The default title font.

    - #### DEFAULT_SUBTITLE_FONT

          public static final java.awt.Font DEFAULT_SUBTITLE_FONT

      The default subtitle font.

    - #### DEFAULT_CHARTBOX_COLOR

          public static final java.awt.Color DEFAULT_CHARTBOX_COLOR

      The default chartbox color.

    - #### DEFAULT_ROW_GRIDLINES_VISIBLE

          public static final boolean DEFAULT_ROW_GRIDLINES_VISIBLE

      The default visibility for gridlines perpendicular to the row-axis.
      See Also:
        Constant Field Values

    - #### DEFAULT_COLUMN_GRIDLINES_VISIBLE

          public static final boolean DEFAULT_COLUMN_GRIDLINES_VISIBLE

      The default visibility for gridlines perpendicular to the column-axis.
      See Also:
        Constant Field Values

    - #### DEFAULT_X_GRIDLINES_VISIBLE

          public static final boolean DEFAULT_X_GRIDLINES_VISIBLE

      The default visibility for gridlines perpendicular to the x-axis.
      See Also:
        Constant Field Values

    - #### DEFAULT_Y_GRIDLINES_VISIBLE

          public static final boolean DEFAULT_Y_GRIDLINES_VISIBLE

      The default visibility for gridlines perpendicular to the y-axis.
      See Also:
        Constant Field Values

    - #### DEFAULT_Z_GRIDLINES_VISIBLE

          public static final boolean DEFAULT_Z_GRIDLINES_VISIBLE

      The default visibility for gridlines perpendicular to the z-axis.
      See Also:
        Constant Field Values

    - #### DEFAULT_GRIDLINE_COLOR

          public static final java.awt.Color DEFAULT_GRIDLINE_COLOR

      The default gridline color.

    - #### DEFAULT_GRIDLINE_STROKE

          public static final java.awt.Stroke DEFAULT_GRIDLINE_STROKE

      The default gridline stroke.

    - #### DEFAULT_SECTION_LABEL_FONT

          public static final java.awt.Font DEFAULT_SECTION_LABEL_FONT

      The default font for pie section labels.

    - #### DEFAULT_SECTION_LABEL_COLOR

          public static final java.awt.Color DEFAULT_SECTION_LABEL_COLOR

      The default color for pie section labels.

    - #### DEFAULT_AXIS_LABEL_FONT

          public static final java.awt.Font DEFAULT_AXIS_LABEL_FONT

      The default font for axis labels.

    - #### DEFAULT_AXIS_LABEL_COLOR

          public static final java.awt.Color DEFAULT_AXIS_LABEL_COLOR

      The default foreground color for axis labels.

    - #### DEFAULT_AXIS_TICK_LABEL_FONT

          public static final java.awt.Font DEFAULT_AXIS_TICK_LABEL_FONT

      The default font for axis tick labels.

    - #### DEFAULT_AXIS_TICK_LABEL_COLOR

          public static final java.awt.Color DEFAULT_AXIS_TICK_LABEL_COLOR

      The default foreground color for axis tick labels.

    - #### DEFAULT_LEGEND_HEADER_FONT

          public static final java.awt.Font DEFAULT_LEGEND_HEADER_FONT

      The default font for legend headers.

    - #### DEFAULT_LEGEND_HEADER_COLOR

          public static final java.awt.Color DEFAULT_LEGEND_HEADER_COLOR

      The default foreground color for the legend header if there is one.

    - #### DEFAULT_LEGEND_ITEM_SHAPE

          public static final java.awt.Shape DEFAULT_LEGEND_ITEM_SHAPE

      The default legend item shape.

    - #### DEFAULT_LEGEND_ITEM_FONT

          public static final java.awt.Font DEFAULT_LEGEND_ITEM_FONT

      The default font for legend item text.

    - #### DEFAULT_LEGEND_ITEM_COLOR

          public static final java.awt.Color DEFAULT_LEGEND_ITEM_COLOR

      The default legend item color.

    - #### DEFAULT_LEGEND_ITEM_BACKGROUND_COLOR

          public static final java.awt.Color DEFAULT_LEGEND_ITEM_BACKGROUND_COLOR

      The default legend item background color.

    - #### DEFAULT_LEGEND_FOOTER_FONT

          public static final java.awt.Font DEFAULT_LEGEND_FOOTER_FONT

      The default font for legend footers.

    - #### DEFAULT_LEGEND_FOOTER_COLOR

          public static final java.awt.Color DEFAULT_LEGEND_FOOTER_COLOR

      The default foreground color for the legend footer if there is one.

    - #### DEFAULT_MARKER_LABEL_FONT

          public static final java.awt.Font DEFAULT_MARKER_LABEL_FONT

    - #### DEFAULT_MARKER_LABEL_COLOR

          public static final java.awt.Color DEFAULT_MARKER_LABEL_COLOR

    - #### DEFAULT_MARKER_LINE_STROKE

          public static final java.awt.Stroke DEFAULT_MARKER_LINE_STROKE

    - #### DEFAULT_MARKER_LINE_COLOR

          public static final java.awt.Color DEFAULT_MARKER_LINE_COLOR

    - #### DEFAULT_MARKER_FILL_COLOR

          public static final java.awt.Color DEFAULT_MARKER_FILL_COLOR

  - ### Constructor Detail

    - #### StandardChartStyle

          public StandardChartStyle()

      Creates a new instance with default attributes.

    - #### StandardChartStyle

          public StandardChartStyle(StandardChartStyle source)

      A copy constructor that creates a new style that is a copy of an existing style (note that the existing style listeners are not copied).
      Parameters:
        `source` - the source style to copy (`null` not permitted).

  - ### Method Detail

    - #### createDefaultFont

          public static java.awt.Font createDefaultFont(int style,
                                                        int size)

      Creates a default font with the specified `style` and `size`. The method attempts to use 'Palatino Linotype' ('Palatino' on MacOSX) but if it is not found it falls back to the `Font.SERIF` font family.
      Parameters:
        `style` - the style (see java.awt.Font).
        `size` - the size.
      Returns:
        The font.
      Since:
        1.3

    - #### getBackgroundPainter

          public RectanglePainter getBackgroundPainter()

      Returns the background painter.
      Specified by:
        `getBackgroundPainter` in interface `ChartStyle`
      Returns:
        The background painter (never `null`).

    - #### setBackgroundPainter

          public void setBackgroundPainter(RectanglePainter painter)

      Sets the background painter.
      Parameters:
        `painter` - the painter (`null` not permitted).

    - #### getTitleFont

          public java.awt.Font getTitleFont()

      Returns the chart title font. The default value is `DEFAULT_TITLE_FONT`.
      Specified by:
        `getTitleFont` in interface `ChartStyle`
      Returns:
        The chart title font (never `null`).

    - #### setTitleFont

          public void setTitleFont(java.awt.Font font)

      Sets the font used for the chart title and sends a `ChartStyleChangeEvent` to all registered listeners.
      Parameters:
        `font` - the font (`null` not permitted).

    - #### getTitleColor

          public java.awt.Color getTitleColor()

      Returns the title color. The default value is `Color.BLACK`.
      Specified by:
        `getTitleColor` in interface `ChartStyle`
      Returns:
        The title color (never `null`).

    - #### setTitleColor

          public void setTitleColor(java.awt.Color color)

      Sets the foreground color for the chart title and sends a change event to all registered listeners.
      Parameters:
        `color` - the color (`null` not permitted).

    - #### getTitleBackgroundColor

          public java.awt.Color getTitleBackgroundColor()

      Returns the background color for the title. The default value is `DEFAULT_TEXT_BACKGROUND_COLOR`.
      Specified by:
        `getTitleBackgroundColor` in interface `ChartStyle`
      Returns:
        The background color (never `null`).

    - #### setTitleBackgroundColor

          public void setTitleBackgroundColor(java.awt.Color color)

      Sets the background color for the title and sends a change event to all registered listeners.
      Parameters:
        `color` - the color (`null` not permitted).

    - #### getSubtitleFont

          public java.awt.Font getSubtitleFont()

      Returns the font used for the chart subtitle. The default value is `DEFAULT_SUBTITLE_FONT`.
      Specified by:
        `getSubtitleFont` in interface `ChartStyle`
      Returns:
        The chart subtitle font (never `null`).

    - #### setSubtitleFont

          public void setSubtitleFont(java.awt.Font font)

      Sets the font used for the chart subtitle and sends a `ChartStyleChangeEvent` to all registered listeners.
      Parameters:
        `font` - the font (`null` not permitted).

    - #### getSubtitleColor

          public java.awt.Color getSubtitleColor()

      Returns the color for the chart subtitle. The default value is `Color.BLACK`.
      Specified by:
        `getSubtitleColor` in interface `ChartStyle`
      Returns:
        The color (never `null`).

    - #### setSubtitleColor

          public void setSubtitleColor(java.awt.Color color)

      Sets the color for the chart subtitle and sends a change event to all registered listeners.
      Parameters:
        `color` - the color (`null` not permitted).

    - #### getSubtitleBackgroundColor

          public java.awt.Color getSubtitleBackgroundColor()

      Returns the background color for the chart subtitle. The default value is `DEFAULT_TEXT_BACKGROUND_COLOR`.
      Specified by:
        `getSubtitleBackgroundColor` in interface `ChartStyle`
      Returns:
        The background color (never `null`).

    - #### setSubtitleBackgroundColor

          public void setSubtitleBackgroundColor(java.awt.Color color)

      Sets the background color for the chart subtitle and sends a change event to all registered listeners.
      Parameters:
        `color` - the color (`null` not permitted).

    - #### getChartBoxColor

          public java.awt.Color getChartBoxColor()

      Returns the color used for the `ChartBox3D` (for those charts that have one). The default value is `DEFAULT_CHARTBOX_COLOR`.
      Specified by:
        `getChartBoxColor` in interface `ChartStyle`
      Returns:
        The color (never `null`).

    - #### setChartBoxColor

          public void setChartBoxColor(java.awt.Color color)

      Sets the color used for the chart box and sends a `ChartStyleChangeEvent` to all registered listeners.
      Parameters:
        `color` - the color (`null` not permitted).

    - #### getColumnAxisGridlinesVisible

          public boolean getColumnAxisGridlinesVisible()

      Returns the flag that controls whether or not gridlines are drawn perpendicular to the column axis in category plots.
      Specified by:
        `getColumnAxisGridlinesVisible` in interface `ChartStyle`
      Returns:
        A boolean.

    - #### getRowAxisGridlinesVisible

          public boolean getRowAxisGridlinesVisible()

      Returns the flag that controls whether or not gridlines are drawn perpendicular to the row axis in category plots.
      Specified by:
        `getRowAxisGridlinesVisible` in interface `ChartStyle`
      Returns:
        A boolean.

    - #### getXAxisGridlinesVisible

          public boolean getXAxisGridlinesVisible()

      Returns the flag that specifies whether or not gridlines are drawn for the x-axis. The default value is `false`.
      Specified by:
        `getXAxisGridlinesVisible` in interface `ChartStyle`
      Returns:
        A boolean.

    - #### setXAxisGridlinesVisible

          public void setXAxisGridlinesVisible(boolean visible)

      Sets the flag that controls whether or not gridlines are drawn for the x-axis and sends a `ChartStyleChangeEvent` to all registered listeners.
      Parameters:
        `visible` - the new flag value.

    - #### getYAxisGridlinesVisible

          public boolean getYAxisGridlinesVisible()

      Returns the flag that specifies whether or not gridlines are drawn for the y-axis. The default value is `true`.
      Specified by:
        `getYAxisGridlinesVisible` in interface `ChartStyle`
      Returns:
        A boolean.

    - #### setYAxisGridlinesVisible

          public void setYAxisGridlinesVisible(boolean visible)

      Sets the flag that controls whether or not gridlines are drawn for the y-axis and sends a `ChartStyleChangeEvent` to all registered listeners.
      Parameters:
        `visible` - the new flag value.

    - #### getZAxisGridlinesVisible

          public boolean getZAxisGridlinesVisible()

      Returns the flag that specifies whether or not gridlines are drawn for the z-axis. The default value is `true`.
      Specified by:
        `getZAxisGridlinesVisible` in interface `ChartStyle`
      Returns:
        A boolean.

    - #### setZAxisGridlinesVisible

          public void setZAxisGridlinesVisible(boolean visible)

      Sets the flag that controls whether or not gridlines are drawn for the z-axis and sends a `ChartStyleChangeEvent` to all registered listeners.
      Parameters:
        `visible` - the new flag value.

    - #### getGridlineColor

          public java.awt.Color getGridlineColor()

      Returns the color used for the gridlines. The default value is `DEFAULT_GRIDLINE_STROKE`.
      Specified by:
        `getGridlineColor` in interface `ChartStyle`
      Returns:
        The color used for the gridlines (never `null`).

    - #### setGridlineColor

          public void setGridlineColor(java.awt.Color color)

      Sets the color for the gridlines and sends a `ChartStyleChangeEvent` to all registered listeners.
      Parameters:
        `color` - the color (`null` not permitted).

    - #### getGridlineStroke

          public java.awt.Stroke getGridlineStroke()

      Returns the stroke used to draw the gridlines. The default value is `DEFAULT_GRIDLINE_STROKE`.
      Specified by:
        `getGridlineStroke` in interface `ChartStyle`
      Returns:
        The stroke (never `null`).

    - #### setGridlineStroke

          public void setGridlineStroke(java.awt.Stroke stroke)

      Sets the stroke used for gridlines and sends a `ChartStyleChangeEvent` to all registered listeners.
      Parameters:
        `stroke` - the stroke (`null` not permitted).

    - #### getSectionLabelFont

          public java.awt.Font getSectionLabelFont()

      Returns the font used for pie section labels. The default value is `DEFAULT_SECTION_LABEL_FONT`.
      Specified by:
        `getSectionLabelFont` in interface `ChartStyle`
      Returns:
        The font used for pie section labels (never `null`).

    - #### setSectionLabelFont

          public void setSectionLabelFont(java.awt.Font font)

      Sets the font used for the pie section labels and sends a `ChartStyleChangeEvent` to all registered listeners.
      Parameters:
        `font` - the font (`null` not permitted).

    - #### getSectionLabelColor

          public java.awt.Color getSectionLabelColor()

      Returns the color used to display pie section labels. The default value is `DEFAULT_SECTION_LABEL_COLOR`.
      Specified by:
        `getSectionLabelColor` in interface `ChartStyle`
      Returns:
        The color (never `null`).

    - #### setSectionLabelColor

          public void setSectionLabelColor(java.awt.Color color)

      Sets the color used for the pie section labels and sends a `ChartStyleChangeEvent` to all registered listeners.
      Parameters:
        `color` - the color (`null` not permitted).

    - #### getStandardColors

          public java.awt.Color[] getStandardColors()

      Returns the standard colors for the style. The default value is initialised by calling `Colors.getDefaultColors()`.
      Specified by:
        `getStandardColors` in interface `ChartStyle`
      Returns:
        The standard colors (never `null`).

    - #### setStandardColors

          public void setStandardColors(java.awt.Color... colors)

      Sets the standard colors for the chart and sends a `ChartStyleChangeEvent` to all registered listeners.
      Parameters:
        `colors` - the colors (`null` not permitted).

    - #### getAxisLabelFont

          public java.awt.Font getAxisLabelFont()

      Returns the font used for the axis label. The default value is `DEFAULT_AXIS_LABEL_FONT`.
      Specified by:
        `getAxisLabelFont` in interface `ChartStyle`
      Returns:
        The font used for the axis label.
      See Also:
        `ChartStyle.getAxisTickLabelFont()`

    - #### setAxisLabelFont

          public void setAxisLabelFont(java.awt.Font font)

      Sets the font used for the axis label and sends a `ChartStyleChangeEvent` to all registered listeners.
      Parameters:
        `font` - the font (`null` not permitted).

    - #### getAxisLabelColor

          public java.awt.Color getAxisLabelColor()

      Returns the foreground color for the axis label (the main label, not the tick labels). The default value is `DEFAULT_AXIS_LABEL_COLOR`.
      Specified by:
        `getAxisLabelColor` in interface `ChartStyle`
      Returns:
        The color (never `null`).

    - #### setAxisLabelColor

          public void setAxisLabelColor(java.awt.Color color)

      Sets the foreground color for the axis label and sends a `ChartStyleChangeEvent` to all registered listeners.
      Parameters:
        `color` - the color (`null` not permitted).

    - #### getAxisTickLabelFont

          public java.awt.Font getAxisTickLabelFont()

      Returns the font used for the axis tick labels. The default value is `DEFAULT_AXIS_TICK_LABEL_FONT`.
      Specified by:
        `getAxisTickLabelFont` in interface `ChartStyle`
      Returns:
        The font (never `null`).
      See Also:
        `ChartStyle.getAxisLabelFont()`

    - #### setAxisTickLabelFont

          public void setAxisTickLabelFont(java.awt.Font font)

      Sets the font used for the axis tick labels and sends a `ChartStyleChangeEvent` to all registered listeners.
      Parameters:
        `font` - the font (`null` not permitted).

    - #### getAxisTickLabelColor

          public java.awt.Color getAxisTickLabelColor()

      Returns the color used to draw the tick labels on the axis. The default value is `DEFAULT_AXIS_TICK_LABEL_COLOR`.
      Specified by:
        `getAxisTickLabelColor` in interface `ChartStyle`
      Returns:
        The color (never `null`).

    - #### setAxisTickLabelColor

          public void setAxisTickLabelColor(java.awt.Color color)

      Sets the foreground color for the axis tick labels and sends a `ChartStyleChangeEvent` to all registered listeners.
      Parameters:
        `color` - the color (`null` not permitted).

    - #### getLegendHeaderFont

          public java.awt.Font getLegendHeaderFont()

      Returns the font used to display the legend header. The default value is `DEFAULT_LEGEND_HEADER_FONT`.
      Specified by:
        `getLegendHeaderFont` in interface `ChartStyle`
      Returns:
        The font (never `null`).

    - #### setLegendHeaderFont

          public void setLegendHeaderFont(java.awt.Font font)

      Sets the legend header font and sends a `ChartStyleChangeEvent` to all registered listeners.
      Parameters:
        `font` - the font (`null` not permitted).

    - #### getLegendHeaderColor

          public java.awt.Color getLegendHeaderColor()

      Returns the foreground color for the legend header. The default value is `DEFAULT_LEGEND_HEADER_COLOR`.
      Specified by:
        `getLegendHeaderColor` in interface `ChartStyle`
      Returns:
        The color (never `null`).

    - #### setLegendHeaderColor

          public void setLegendHeaderColor(java.awt.Color color)

      Sets the foreground color for the legend header and sends a `ChartStyleChangeEvent` to all registered listeners.
      Parameters:
        `color` - the color (`null` not permitted).

    - #### getLegendHeaderBackgroundColor

          public java.awt.Color getLegendHeaderBackgroundColor()

      Returns the background color for the legend header. The default value is `DEFAULT_TEXT_BACKGROUND_COLOR`.
      Specified by:
        `getLegendHeaderBackgroundColor` in interface `ChartStyle`
      Returns:
        The color (never `null`).

    - #### setLegendHeaderBackgroundColor

          public void setLegendHeaderBackgroundColor(java.awt.Color color)

      Sets the background color for the legend header and sends a `ChartStyleChangeEvent` to all registered listeners.
      Parameters:
        `color` - the color (`null` not permitted).

    - #### getLegendItemShape

          public java.awt.Shape getLegendItemShape()

      Returns the standard shape for legend items. The default value is `DEFAULT_LEGEND_ITEM_SHAPE`.
      Specified by:
        `getLegendItemShape` in interface `ChartStyle`
      Returns:
        The legend shape (never `null`).

    - #### setLegendItemShape

          public void setLegendItemShape(java.awt.Shape shape)

      Sets the default shape for legend items and sends a `ChartStyleChangeEvent` to all registered listeners.
      Parameters:
        `shape` - the shape (`null` not permitted).

    - #### getLegendItemFont

          public java.awt.Font getLegendItemFont()

      Returns the font used for legend item text. The default value is `DEFAULT_LEGEND_ITEM_FONT`.
      Specified by:
        `getLegendItemFont` in interface `ChartStyle`
      Returns:
        The font used for legend item text (never `null`).

    - #### setLegendItemFont

          public void setLegendItemFont(java.awt.Font font)

      Sets the legend item font and sends a `ChartStyleChangeEvent` to all registered listeners.
      Parameters:
        `font` - the font (`null` not permitted).

    - #### getLegendItemColor

          public java.awt.Color getLegendItemColor()

      Returns the foreground color used for the legend items. The default value is `DEFAULT_LEGEND_ITEM_COLOR`.
      Specified by:
        `getLegendItemColor` in interface `ChartStyle`
      Returns:
        The color (never `null`).

    - #### setLegendItemColor

          public void setLegendItemColor(java.awt.Color color)

      Sets the foreground color used for legend item text and sends a `ChartStyleChangeEvent` to all registered listeners.
      Parameters:
        `color` - the color (`null` not permitted).

    - #### getLegendItemBackgroundColor

          public java.awt.Color getLegendItemBackgroundColor()

      Returns the background color for legend items. The default value is `DEFAULT_LEGEND_ITEM_BACKGROUND_COLOR`.
      Specified by:
        `getLegendItemBackgroundColor` in interface `ChartStyle`
      Returns:
        The color (never `null`).

    - #### setLegendItemBackgroundColor

          public void setLegendItemBackgroundColor(java.awt.Color color)

      Sets the background color for legend items and sends a `ChartStyleChangeEvent` to all registered listeners.
      Parameters:
        `color` - the color (`null` not permitted).

    - #### getLegendFooterFont

          public java.awt.Font getLegendFooterFont()

      Returns the font for the legend footer. The default value is `DEFAULT_LEGEND_FOOTER_FONT`.
      Specified by:
        `getLegendFooterFont` in interface `ChartStyle`
      Returns:
        The font (never `null`).

    - #### setLegendFooterFont

          public void setLegendFooterFont(java.awt.Font font)

      Sets the legend footer font and sends a `ChartStyleChangeEvent` to all registered listeners.
      Parameters:
        `font` - the font (`null` not permitted).

    - #### getLegendFooterColor

          public java.awt.Color getLegendFooterColor()

      Returns the foreground color for the legend footer. The default value is `DEFAULT_LEGEND_FOOTER_COLOR`.
      Specified by:
        `getLegendFooterColor` in interface `ChartStyle`
      Returns:
        The color (never `null`).

    - #### setLegendFooterColor

          public void setLegendFooterColor(java.awt.Color color)

      Sets the foreground color for the legend footer and sends a `ChartStyleChangeEvent` to all registered listeners.
      Parameters:
        `color` - the color (`null` not permitted).

    - #### getLegendFooterBackgroundColor

          public java.awt.Color getLegendFooterBackgroundColor()

      Returns the background color for the legend footer. The default value is `DEFAULT_TEXT_BACKGROUND_COLOR`.
      Specified by:
        `getLegendFooterBackgroundColor` in interface `ChartStyle`
      Returns:
        The color (never `null`).

    - #### setLegendFooterBackgroundColor

          public void setLegendFooterBackgroundColor(java.awt.Color color)

      Sets the background color for the legend footer and sends a `ChartStyleChangeEvent` to all registered listeners.
      Parameters:
        `color` - the color (`null` not permitted).

    - #### getMarkerLabelFont

          public java.awt.Font getMarkerLabelFont()

      Returns the font used to draw marker labels.
      Specified by:
        `getMarkerLabelFont` in interface `ChartStyle`
      Returns:
        The font used to draw marker labels (never `null`).

    - #### setMarkerLabelFont

          public void setMarkerLabelFont(java.awt.Font font)

      Sets the marker label font and sends a change event to all registered listeners.
      Parameters:
        `font` - the font (`null` not permitted).

    - #### getMarkerLabelColor

          public java.awt.Color getMarkerLabelColor()

      Returns the color for the marker labels.
      Specified by:
        `getMarkerLabelColor` in interface `ChartStyle`
      Returns:
        The color for the marker labels (never `null`).

    - #### setMarkerLabelColor

          public void setMarkerLabelColor(java.awt.Color color)

      Sets the color for the marker labels and sends a change event to all registered listeners.
      Parameters:
        `color` - the color (`null` not permitted).

    - #### getMarkerLineStroke

          public java.awt.Stroke getMarkerLineStroke()

      Returns the stroke used to draw marker lines.
      Specified by:
        `getMarkerLineStroke` in interface `ChartStyle`
      Returns:
        The stroke used to draw marker lines (never `null`).

    - #### setMarkerLineStroke

          public void setMarkerLineStroke(java.awt.Stroke stroke)

      Sets the stroke for the marker lines and sends a change event to all registered listeners.
      Parameters:
        `stroke` - the stroke (`null` not permitted).

    - #### getMarkerLineColor

          public java.awt.Color getMarkerLineColor()

      Returns the color used to draw marker lines.
      Specified by:
        `getMarkerLineColor` in interface `ChartStyle`
      Returns:
        The color used to draw marker lines (never `null`).

    - #### setMarkerLineColor

          public void setMarkerLineColor(java.awt.Color color)

      Sets the marker line color and sends a change event to all registered listeners.
      Parameters:
        `color` - the color (`null` not permitted).

    - #### getMarkerFillColor

          public java.awt.Color getMarkerFillColor()

      Returns the color used to fill the band representing the marker range.
      Specified by:
        `getMarkerFillColor` in interface `ChartStyle`
      Returns:
        The fill color (never `null`).

    - #### setMarkerFillColor

          public void setMarkerFillColor(java.awt.Color color)

      Sets the marker fill color and sends a change event to all registered listeners.
      Parameters:
        `color` - the color (`null` not permitted).

    - #### addChangeListener

          public void addChangeListener(ChartStyleChangeListener listener)

      Registers a listener to receive notification of changes to the chart. When a style is added to a chart, the chart will register as a listener on the style.
      Specified by:
        `addChangeListener` in interface `ChartStyle`
      Parameters:
        `listener` - the listener.

    - #### removeChangeListener

          public void removeChangeListener(ChartStyleChangeListener listener)

      Deregisters a listener so that it no longer receives notification of changes to the chart.
      Specified by:
        `removeChangeListener` in interface `ChartStyle`
      Parameters:
        `listener` - the listener.

    - #### notifyListeners

          public void notifyListeners(ChartStyleChangeEvent event)

      Notifies all registered listeners that the chart style has been modified.
      Parameters:
        `event` - information about the change event.

    - #### isNotify

          public boolean isNotify()

      Returns a flag that controls whether or not change events are sent to registered listeners.
      Returns:
        A boolean.
      See Also:
        `setNotify(boolean)`

    - #### setNotify

          public void setNotify(boolean notify)

      Sets a flag that controls whether or not listeners receive `ChartStyleChangeEvent` notifications. This can be useful when updating multiple style attributes, you can call setNotify(false) first, update the styles, then call setNotify(true) at the end.
      Parameters:
        `notify` - a boolean.
      See Also:
        `isNotify()`

    - #### fireChangeEvent

          protected void fireChangeEvent()

      Sends a `ChartStyleChangeEvent` to all registered listeners.

    - #### clone

          public ChartStyle clone()

      Returns a clone of the chart style (note that the change listeners are not cloned).
      Specified by:
        `clone` in interface `ChartStyle`
      Overrides:
        `clone` in class `java.lang.Object`
      Returns:
        A clone (never `null`).

    - #### equals

          public boolean equals(java.lang.Object obj)

      Tests this instance for equality with an arbitrary object.
      Overrides:
        `equals` in class `java.lang.Object`
      Parameters:
        `obj` - the object (`null` permitted).
      Returns:
        A boolean.